/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include "lcd.h"
#include "timer.h"
#include "lin.h"
#include "led.h"
#include "usart.h"
#define F_CPU  8000000UL  // 8 MHz
#include <avr/delay.h>


/******************************************************************************
* Macros
******************************************************************************/
//USART baud rat: 19.2kbps @ 8MHz
#define USART_BAUD 25
/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/
char szoveg[100]={};

/******************************************************************************
* External Variables
******************************************************************************/
extern volatile uint8_t Task_1000ms,Task_100ms,Task_10ms;

/******************************************************************************
* Local Function Declarations
******************************************************************************/

/******************************************************************************
* Local Function Definitions
******************************************************************************/

/******************************************************************************
* Global Function Definitions
******************************************************************************/
int main(void)
{
	DDRA=0xff;
	DDRE=(1<<PE1) | (0<<PE0) | (1<<PE2);
	PORTE|=(1<<PE2); // LIN CS
	lcdinit();
	TIMER0_Init();
	LIN_Init();
	sei();


	
	
	while(1)
	{
		
		
		if (Task_1000ms)
		{		
			Task_1000ms = FALSE;
		}
		if (Task_100ms)
		{
			LIN_send_headers_task();
			sprintf(szoveg,"%2d V",get_signal(0)/512+4);
			lcd_set_address(0);
			lcdreir(szoveg);
			Task_100ms = FALSE;
		}
		if (Task_10ms)
		{
			LIN_process_bytes_task();
			Task_10ms = FALSE;
		}
	}
}